# gnocchi

## metric aggregates

Get measurements of aggregated metrics.

    openstack metric aggregates
        [--format-config-file FORMAT_CONFIG]
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--resource-type RESOURCE_TYPE]
        [--start START]
        [--stop STOP]
        [--granularity GRANULARITY]
        [--needed-overlap NEEDED_OVERLAP]
        [--groupby GROUPBY]
        [--fill FILL]
        [--use-history USE_HISTORY]
        operations
        [search]

--format-config-file <FORMAT_CONFIG>

  Config file for the dict-to-csv formatter

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--resource-type <RESOURCE_TYPE>

  Resource type to query

--start <START>

  beginning of the period

--stop <STOP>

  end of the period

--granularity <GRANULARITY>

  granularity to retrieve

--needed-overlap <NEEDED_OVERLAP>

  percentage of overlap across datapoints

--groupby <GROUPBY>

  Attribute to use to group resources

--fill <FILL>

  Value to use when backfilling timestamps with missing values in a subset of series. Value should be a float or ‘null’.

--use-history <USE_HISTORY>

  Indicates if Gnocchi server should respond with the resource tags history for the aggregation query. If set to False, only the latest tag values will be returned. Otherwise, the measures will be split proportionally if a tag has been changed in the granularity requested.

operations

  Operations to apply to time series

search

  A query to filter resource. The syntax is a combination of attribute, operator and value. For example: id=90d58eea-70d7-4294-a49a-170dcdf44c3c would filter resource with a certain id. More complex queries can be built, e.g.: not (flavor_id!=”1” and memory>=24). Use “” to force data to be interpreted as string. Supported operators are: not, and, ∧ or, ∨, >=, <=, !=, >, <, =, ==, eq, ne, lt, gt, ge, le, in, like, ≠, ≥, ≤, like, in.

This command is provided by the gnocchiclient plugin.

## metric archive-policy create

Create an archive policy.

    openstack metric archive-policy create
        -d <DEFINITION>
        [-b BACK_WINDOW]
        [-m AGGREGATION_METHODS]
        name

-d <DEFINITION>, --definition <DEFINITION>

  two attributes (separated by ‘,’) of an archive policy definition with its name and value separated with a ‘:’

-b <BACK_WINDOW>, --back-window <BACK_WINDOW>

  back window of the archive policy

-m <AGGREGATION_METHODS>, --aggregation-method <AGGREGATION_METHODS>

  aggregation method of the archive policy

name

  name of the archive policy

This command is provided by the gnocchiclient plugin.

## metric archive-policy delete

Delete an archive policy.

    openstack metric archive-policy delete name

name

  Name of the archive policy

This command is provided by the gnocchiclient plugin.

## metric archive-policy list

List archive policies.

    openstack metric archive-policy list
        [--format-config-file FORMAT_CONFIG]
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]

--format-config-file <FORMAT_CONFIG>

  Config file for the dict-to-csv formatter

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

This command is provided by the gnocchiclient plugin.

## metric archive-policy show

Show an archive policy.

    openstack metric archive-policy show name

name

  Name of the archive policy

This command is provided by the gnocchiclient plugin.

## metric archive-policy update

Update an archive policy.

    openstack metric archive-policy update -d <DEFINITION> name

-d <DEFINITION>, --definition <DEFINITION>

  two attributes (separated by ‘,’) of an archive policy definition with its name and value separated with a ‘:’

name

  name of the archive policy

This command is provided by the gnocchiclient plugin.

## metric archive-policy-rule create

Create an archive policy rule.

    openstack metric archive-policy-rule create
        -a ARCHIVE_POLICY_NAME
        -m METRIC_PATTERN
        name

-a <ARCHIVE_POLICY_NAME>, --archive-policy-name <ARCHIVE_POLICY_NAME>

  Archive policy name

-m <METRIC_PATTERN>, --metric-pattern <METRIC_PATTERN>

  Wildcard of metric name to match

name

  Rule name

This command is provided by the gnocchiclient plugin.

## metric archive-policy-rule delete

Delete an archive policy rule.

    openstack metric archive-policy-rule delete name

name

  Name of the archive policy rule

This command is provided by the gnocchiclient plugin.

## metric archive-policy-rule list

List archive policy rules.

    openstack metric archive-policy-rule list
        [--format-config-file FORMAT_CONFIG]
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]

--format-config-file <FORMAT_CONFIG>

  Config file for the dict-to-csv formatter

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

This command is provided by the gnocchiclient plugin.

## metric archive-policy-rule show

Show an archive policy rule.

    openstack metric archive-policy-rule show name

name

  Name of the archive policy rule

This command is provided by the gnocchiclient plugin.

## metric benchmark measures add

Do benchmark testing of adding measurements.

    openstack metric benchmark measures add
        [--resource-id RESOURCE_ID]
        [--workers WORKERS]
        --count COUNT
        [--batch BATCH]
        [--timestamp-start TIMESTAMP_START]
        [--timestamp-end TIMESTAMP_END]
        [--wait]
        metric

--resource-id <RESOURCE_ID>, -r <RESOURCE_ID>

  ID of the resource

--workers <WORKERS>, -w <WORKERS>

  Number of workers to use

--count <COUNT>, -n <COUNT>

  Number of total measures to send

--batch <BATCH>, -b <BATCH>

  Number of measures to send in each batch

--timestamp-start <TIMESTAMP_START>, -s <TIMESTAMP_START>

  First timestamp to use

--timestamp-end <TIMESTAMP_END>, -e <TIMESTAMP_END>

  Last timestamp to use

--wait

  Wait for all measures to be processed

metric

  ID or name of the metric

This command is provided by the gnocchiclient plugin.

## metric benchmark measures show

Do benchmark testing of measurements show.

    openstack metric benchmark measures show
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--utc]
        [--resource-id RESOURCE_ID]
        [--aggregation AGGREGATION]
        [--start START]
        [--stop STOP]
        [--granularity GRANULARITY]
        [--refresh]
        [--resample RESAMPLE]
        [--workers WORKERS]
        --count COUNT
        metric

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--utc

  Return timestamps as UTC

--resource-id <RESOURCE_ID>, -r <RESOURCE_ID>

  ID of the resource

--aggregation <AGGREGATION>

  aggregation to retrieve

--start <START>

  beginning of the period

--stop <STOP>

  end of the period

--granularity <GRANULARITY>

  granularity to retrieve

--refresh

  force aggregation of all known measures

--resample <RESAMPLE>

  granularity to resample time-series to (in seconds)

--workers <WORKERS>, -w <WORKERS>

  Number of workers to use

--count <COUNT>, -n <COUNT>

  Number of total measures to send

metric

  ID or name of the metric

This command is provided by the gnocchiclient plugin.

## metric benchmark metric create

Do benchmark testing of metric creation.

    openstack metric benchmark metric create
        [--resource-id RESOURCE_ID]
        [--archive-policy-name ARCHIVE_POLICY_NAME]
        [--workers WORKERS]
        --count COUNT
        [--keep]

--resource-id <RESOURCE_ID>, -r <RESOURCE_ID>

  ID of the resource

--archive-policy-name <ARCHIVE_POLICY_NAME>, -a <ARCHIVE_POLICY_NAME>

  name of the archive policy

--workers <WORKERS>, -w <WORKERS>

  Number of workers to use

--count <COUNT>, -n <COUNT>

  Number of metrics to create

--keep, -k

  Keep created metrics

This command is provided by the gnocchiclient plugin.

## metric benchmark metric show

Do benchmark testing of metric show.

    openstack metric benchmark metric show
        [--resource-id RESOURCE_ID]
        [--workers WORKERS]
        --count COUNT
        metric
        [metric ...]

--resource-id <RESOURCE_ID>, -r <RESOURCE_ID>

  ID of the resource

--workers <WORKERS>, -w <WORKERS>

  Number of workers to use

--count <COUNT>, -n <COUNT>

  Number of metrics to get

metric

  ID or name of the metrics

This command is provided by the gnocchiclient plugin.

## metric capabilities list

List capabilities.

    openstack metric capabilities list

This command is provided by the gnocchiclient plugin.

## metric create

Create a metric.

    openstack metric create
        [--resource-id RESOURCE_ID]
        [--archive-policy-name ARCHIVE_POLICY_NAME]
        [--unit UNIT]
        [METRIC_NAME]

--resource-id <RESOURCE_ID>, -r <RESOURCE_ID>

  ID of the resource

--archive-policy-name <ARCHIVE_POLICY_NAME>, -a <ARCHIVE_POLICY_NAME>

  name of the archive policy

--unit <UNIT>, -u <UNIT>

  unit of the metric

METRIC_NAME

  Name of the metric

This command is provided by the gnocchiclient plugin.

## metric delete

Delete a metric.

    openstack metric delete [--resource-id RESOURCE_ID] metric [metric ...]

--resource-id <RESOURCE_ID>, -r <RESOURCE_ID>

  ID of the resource

metric

  IDs or names of the metric

This command is provided by the gnocchiclient plugin.

## metric list

List metrics.

    openstack metric list
        [--format-config-file FORMAT_CONFIG]
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--limit <LIMIT>]
        [--marker <MARKER>]
        [--sort <SORT>]

--format-config-file <FORMAT_CONFIG>

  Config file for the dict-to-csv formatter

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--limit <LIMIT>

  Number of metrics to return (Default is server default)

--marker <MARKER>

  Last item of the previous listing. Return the next results after this value

--sort <SORT>

  Sort of metric attribute (example: user_id:desc-nullslast

This command is provided by the gnocchiclient plugin.

## metric measures add

Add measurements to a metric.

    openstack metric measures add
        [--resource-id RESOURCE_ID]
        -m MEASURE
        metric

--resource-id <RESOURCE_ID>, -r <RESOURCE_ID>

  ID of the resource

-m <MEASURE>, --measure <MEASURE>

  timestamp and value of a measure separated with a ‘@’

metric

  ID or name of the metric

This command is provided by the gnocchiclient plugin.

## metric measures aggregation

Get measurements of aggregated metrics.

    openstack metric measures aggregation
        [--format-config-file FORMAT_CONFIG]
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--utc]
        -m METRIC
        [METRIC ...]
        [--aggregation AGGREGATION]
        [--reaggregation REAGGREGATION]
        [--start START]
        [--stop STOP]
        [--granularity GRANULARITY]
        [--needed-overlap NEEDED_OVERLAP]
        [--query QUERY]
        [--resource-type RESOURCE_TYPE]
        [--groupby GROUPBY]
        [--refresh]
        [--resample RESAMPLE]
        [--fill FILL]

--format-config-file <FORMAT_CONFIG>

  Config file for the dict-to-csv formatter

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--utc

  Return timestamps as UTC

-m <METRIC>, --metric <METRIC>

  metrics IDs or metric name

--aggregation <AGGREGATION>

  granularity aggregation function to retrieve

--reaggregation <REAGGREGATION>

  groupby aggregation function to retrieve

--start <START>

  beginning of the period

--stop <STOP>

  end of the period

--granularity <GRANULARITY>

  granularity to retrieve

--needed-overlap <NEEDED_OVERLAP>

  percent of datapoints in each metrics required

--query <QUERY>

  A query to filter resource. The syntax is a combination of attribute, operator and value. For example: id=90d58eea-70d7-4294-a49a-170dcdf44c3c would filter resource with a certain id. More complex queries can be built, e.g.: not (flavor_id!=”1” and memory>=24). Use “” to force data to be interpreted as string. Supported operators are: not, and, ∧ or, ∨, >=, <=, !=, >, <, =, ==, eq, ne, lt, gt, ge, le, in, like, ≠, ≥, ≤, like, in.

--resource-type <RESOURCE_TYPE>

  Resource type to query

--groupby <GROUPBY>

  Attribute to use to group resources

--refresh

  force aggregation of all known measures

--resample <RESAMPLE>

  granularity to resample time-series to (in seconds)

--fill <FILL>

  Value to use when backfilling timestamps with missing values in a subset of series. Value should be a float or ‘null’.

This command is provided by the gnocchiclient plugin.

## metric measures batch-metrics

    openstack metric measures batch-metrics file

file

  File containing measurements to batch or - for stdin (see Gnocchi REST API docs for the format

This command is provided by the gnocchiclient plugin.

## metric measures batch-resources-metrics

    openstack metric measures batch-resources-metrics
        [--create-metrics]
        file

--create-metrics

  Create unknown metrics

file

  File containing measurements to batch or - for stdin (see Gnocchi REST API docs for the format

This command is provided by the gnocchiclient plugin.

## metric measures show

Get measurements of a metric.

    openstack metric measures show
        [--format-config-file FORMAT_CONFIG]
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--utc]
        [--resource-id RESOURCE_ID]
        [--aggregation AGGREGATION]
        [--start START]
        [--stop STOP]
        [--granularity GRANULARITY]
        [--refresh]
        [--resample RESAMPLE]
        metric

--format-config-file <FORMAT_CONFIG>

  Config file for the dict-to-csv formatter

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--utc

  Return timestamps as UTC

--resource-id <RESOURCE_ID>, -r <RESOURCE_ID>

  ID of the resource

--aggregation <AGGREGATION>

  aggregation to retrieve

--start <START>

  beginning of the period

--stop <STOP>

  end of the period

--granularity <GRANULARITY>

  granularity to retrieve

--refresh

  force aggregation of all known measures

--resample <RESAMPLE>

  granularity to resample time-series to (in seconds)

metric

  ID or name of the metric

This command is provided by the gnocchiclient plugin.

## metric resource batch delete

Delete a batch of resources based on attribute values.

    openstack metric resource batch delete [--type RESOURCE_TYPE] query

--type <RESOURCE_TYPE>, -t <RESOURCE_TYPE>

  Type of resource

query

  A query to filter resource. The syntax is a combination of attribute, operator and value. For example: id=90d58eea-70d7-4294-a49a-170dcdf44c3c would filter resource with a certain id. More complex queries can be built, e.g.: not (flavor_id!=”1” and memory>=24). Use “” to force data to be interpreted as string. Supported operators are: not, and, ∧ or, ∨, >=, <=, !=, >, <, =, ==, eq, ne, lt, gt, ge, le, in, like, ≠, ≥, ≤, like, in.

This command is provided by the gnocchiclient plugin.

## metric resource create

Create a resource.

    openstack metric resource create
        [--type RESOURCE_TYPE]
        [-a ATTRIBUTE]
        [-m ADD_METRIC]
        [-n CREATE_METRIC]
        resource_id

--type <RESOURCE_TYPE>, -t <RESOURCE_TYPE>

  Type of resource

-a <ATTRIBUTE>, --attribute <ATTRIBUTE>

  name and value of an attribute separated with a ‘:’

-m <ADD_METRIC>, --add-metric <ADD_METRIC>

  name:id of a metric to add

-n <CREATE_METRIC>, --create-metric <CREATE_METRIC>

  name:archive_policy_name of a metric to create

resource_id

  ID of the resource

This command is provided by the gnocchiclient plugin.

## metric resource delete

Delete a resource.

    openstack metric resource delete resource_id

resource_id

  ID of the resource

This command is provided by the gnocchiclient plugin.

## metric resource history

Show the history of a resource.

    openstack metric resource history
        [--format-config-file FORMAT_CONFIG]
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--details]
        [--limit <LIMIT>]
        [--marker <MARKER>]
        [--sort <SORT>]
        [--type RESOURCE_TYPE]
        resource_id

--format-config-file <FORMAT_CONFIG>

  Config file for the dict-to-csv formatter

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--details

  Show all attributes of generic resources

--limit <LIMIT>

  Number of resources to return (Default is server default)

--marker <MARKER>

  Last item of the previous listing. Return the next results after this value

--sort <SORT>

  Sort of resource attribute (example: user_id:desc-nullslast

--type <RESOURCE_TYPE>, -t <RESOURCE_TYPE>

  Type of resource

resource_id

  ID of a resource

This command is provided by the gnocchiclient plugin.

## metric resource list

List resources.

    openstack metric resource list
        [--format-config-file FORMAT_CONFIG]
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--details]
        [--history]
        [--limit <LIMIT>]
        [--marker <MARKER>]
        [--sort <SORT>]
        [--type RESOURCE_TYPE]

--format-config-file <FORMAT_CONFIG>

  Config file for the dict-to-csv formatter

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--details

  Show all attributes of generic resources

--history

  Show history of the resources

--limit <LIMIT>

  Number of resources to return (Default is server default)

--marker <MARKER>

  Last item of the previous listing. Return the next results after this value

--sort <SORT>

  Sort of resource attribute (example: user_id:desc-nullslast

--type <RESOURCE_TYPE>, -t <RESOURCE_TYPE>

  Type of resource

This command is provided by the gnocchiclient plugin.

## metric resource search

Search resources with specified query rules.

    openstack metric resource search
        [--format-config-file FORMAT_CONFIG]
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--details]
        [--history]
        [--limit <LIMIT>]
        [--marker <MARKER>]
        [--sort <SORT>]
        [--type RESOURCE_TYPE]
        query

--format-config-file <FORMAT_CONFIG>

  Config file for the dict-to-csv formatter

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--details

  Show all attributes of generic resources

--history

  Show history of the resources

--limit <LIMIT>

  Number of resources to return (Default is server default)

--marker <MARKER>

  Last item of the previous listing. Return the next results after this value

--sort <SORT>

  Sort of resource attribute (example: user_id:desc-nullslast

--type <RESOURCE_TYPE>, -t <RESOURCE_TYPE>

  Type of resource

query

  A query to filter resource. The syntax is a combination of attribute, operator and value. For example: id=90d58eea-70d7-4294-a49a-170dcdf44c3c would filter resource with a certain id. More complex queries can be built, e.g.: not (flavor_id!=”1” and memory>=24). Use “” to force data to be interpreted as string. Supported operators are: not, and, ∧ or, ∨, >=, <=, !=, >, <, =, ==, eq, ne, lt, gt, ge, le, in, like, ≠, ≥, ≤, like, in.

This command is provided by the gnocchiclient plugin.

## metric resource show

Show a resource.

    openstack metric resource show [--type RESOURCE_TYPE] resource_id

--type <RESOURCE_TYPE>, -t <RESOURCE_TYPE>

  Type of resource

resource_id

  ID of a resource

This command is provided by the gnocchiclient plugin.

## metric resource update

Update a resource.

    openstack metric resource update
        [--type RESOURCE_TYPE]
        [-a ATTRIBUTE]
        [-m ADD_METRIC]
        [-n CREATE_METRIC]
        [-d DELETE_METRIC]
        resource_id

--type <RESOURCE_TYPE>, -t <RESOURCE_TYPE>

  Type of resource

-a <ATTRIBUTE>, --attribute <ATTRIBUTE>

  name and value of an attribute separated with a ‘:’

-m <ADD_METRIC>, --add-metric <ADD_METRIC>

  name:id of a metric to add

-n <CREATE_METRIC>, --create-metric <CREATE_METRIC>

  name:archive_policy_name of a metric to create

-d <DELETE_METRIC>, --delete-metric <DELETE_METRIC>

  Name of a metric to delete

resource_id

  ID of the resource

This command is provided by the gnocchiclient plugin.

## metric resource-type create

Create a resource type.

    openstack metric resource-type create [-a ATTRIBUTE] name

-a <ATTRIBUTE>, --attribute <ATTRIBUTE>

  attribute definition, attribute_name:attribute_type:attribute_is_required:attribute_type_option_name=attribute_type_option_value:… For example: display_name:string:true:max_length=255

name

  name of the resource type

This command is provided by the gnocchiclient plugin.

## metric resource-type delete

Delete a resource type.

    openstack metric resource-type delete name

name

  name of the resource type

This command is provided by the gnocchiclient plugin.

## metric resource-type list

List resource types.

    openstack metric resource-type list
        [--format-config-file FORMAT_CONFIG]
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]

--format-config-file <FORMAT_CONFIG>

  Config file for the dict-to-csv formatter

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

This command is provided by the gnocchiclient plugin.

## metric resource-type show

Show a resource type.

    openstack metric resource-type show name

name

  name of the resource type

This command is provided by the gnocchiclient plugin.

## metric resource-type update

Create a resource type.

    openstack metric resource-type update
        [-a ATTRIBUTE]
        [-r REMOVE_ATTRIBUTE]
        name

-a <ATTRIBUTE>, --attribute <ATTRIBUTE>

  attribute definition, attribute_name:attribute_type:attribute_is_required:attribute_type_option_name=attribute_type_option_value:… For example: display_name:string:true:max_length=255

-r <REMOVE_ATTRIBUTE>, --remove-attribute <REMOVE_ATTRIBUTE>

  attribute name

name

  name of the resource type

This command is provided by the gnocchiclient plugin.

## metric server version

Show the version of Gnocchi server.

    openstack metric server version

This command is provided by the gnocchiclient plugin.

## metric show

Show a metric.

    openstack metric show [--resource-id RESOURCE_ID] metric

--resource-id <RESOURCE_ID>, -r <RESOURCE_ID>

  ID of the resource

metric

  ID or name of the metric

This command is provided by the gnocchiclient plugin.

## metric status

Show the status of measurements processing.

    openstack metric status

This command is provided by the gnocchiclient plugin.

this page last updated: 2026-04-01 09:44:20

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.